#!/bin/bash
set -e 

USERNAME=$1
if [ -z "$USERNAME" ]; then
    USERNAME=root
fi

# if /.setup_done does not exist then run setup
if [ ! -f /.setup_done ]; then
	echo "setup dependencies" 
	su - $USERNAME <<-EOF
		cd /workspace
		mvn -o generate-resources -P$SPRING_PROFILES_ACTIVE -Dmaven.test.skip=true -Dmaven.gitcommitid.skip=true
	EOF
    touch /.setup_done
fi
