package com.emerald.rcm.backend.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import jakarta.persistence.*;
import jakarta.validation.constraints.*;
import java.io.Serializable;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A QuestionnaireNonConformity.
 */
@Entity
@Table(name = "questionnaire_non_conformity")
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
@SuppressWarnings("common-java:DuplicatedBlocks")
public class QuestionnaireNonConformity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "sequenceGenerator")
    @SequenceGenerator(name = "sequenceGenerator")
    @Column(name = "id")
    private Long id;

    @NotNull
    @Column(name = "questionnaire_name", nullable = false)
    private String questionnaireName;

    @Lob
    @Column(name = "comments", nullable = false)
    private String comments;

    @NotNull
    @Column(name = "compliance", nullable = false)
    private String compliance;

    @ManyToOne(optional = false)
    @NotNull
    @JsonIgnoreProperties(value = { "securityControl", "securityMetrics" }, allowSetters = true)
    private Tom tom;

    // jhipster-needle-entity-add-field - JHipster will add fields here

    public Long getId() {
        return this.id;
    }

    public QuestionnaireNonConformity id(Long id) {
        this.setId(id);
        return this;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getQuestionnaireName() {
        return this.questionnaireName;
    }

    public QuestionnaireNonConformity questionnaireName(String questionnaireName) {
        this.setQuestionnaireName(questionnaireName);
        return this;
    }

    public void setQuestionnaireName(String questionnaireName) {
        this.questionnaireName = questionnaireName;
    }

    public String getComments() {
        return this.comments;
    }

    public QuestionnaireNonConformity comments(String comments) {
        this.setComments(comments);
        return this;
    }

    public void setComments(String comments) {
        this.comments = comments;
    }

    public String getCompliance() {
        return this.compliance;
    }

    public QuestionnaireNonConformity compliance(String compliance) {
        this.setCompliance(compliance);
        return this;
    }

    public void setCompliance(String compliance) {
        this.compliance = compliance;
    }

    public Tom getTom() {
        return this.tom;
    }

    public void setTom(Tom tom) {
        this.tom = tom;
    }

    public QuestionnaireNonConformity tom(Tom tom) {
        this.setTom(tom);
        return this;
    }

    // jhipster-needle-entity-add-getters-setters - JHipster will add getters and setters here

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof QuestionnaireNonConformity)) {
            return false;
        }
        return getId() != null && getId().equals(((QuestionnaireNonConformity) o).getId());
    }

    @Override
    public int hashCode() {
        // see https://vladmihalcea.com/how-to-implement-equals-and-hashcode-using-the-jpa-entity-identifier/
        return getClass().hashCode();
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "QuestionnaireNonConformity{" +
            "id=" + getId() +
            ", questionnaireName='" + getQuestionnaireName() + "'" +
            ", comments='" + getComments() + "'" +
            ", compliance='" + getCompliance() + "'" +
            "}";
    }
}
