package com.emerald.rcm.backend.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import jakarta.persistence.*;
import jakarta.validation.constraints.*;
import java.io.Serializable;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A ReferenceTom.
 */
@Entity
@Table(name = "reference_tom")
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
@SuppressWarnings("common-java:DuplicatedBlocks")
public class ReferenceTom implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "sequenceGenerator")
    @SequenceGenerator(name = "sequenceGenerator")
    @Column(name = "id")
    private Long id;

    @NotNull
    @Column(name = "reference_tom_impl", nullable = false)
    private String referenceTomImpl;

    @ManyToOne(optional = false)
    @NotNull
    @JsonIgnoreProperties(value = { "securityControl", "securityMetrics" }, allowSetters = true)
    private Tom tom;

    // jhipster-needle-entity-add-field - JHipster will add fields here

    public Long getId() {
        return this.id;
    }

    public ReferenceTom id(Long id) {
        this.setId(id);
        return this;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getReferenceTomImpl() {
        return this.referenceTomImpl;
    }

    public ReferenceTom referenceTomImpl(String referenceTomImpl) {
        this.setReferenceTomImpl(referenceTomImpl);
        return this;
    }

    public void setReferenceTomImpl(String referenceTomImpl) {
        this.referenceTomImpl = referenceTomImpl;
    }

    public Tom getTom() {
        return this.tom;
    }

    public void setTom(Tom tom) {
        this.tom = tom;
    }

    public ReferenceTom tom(Tom tom) {
        this.setTom(tom);
        return this;
    }

    // jhipster-needle-entity-add-getters-setters - JHipster will add getters and setters here

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof ReferenceTom)) {
            return false;
        }
        return getId() != null && getId().equals(((ReferenceTom) o).getId());
    }

    @Override
    public int hashCode() {
        // see https://vladmihalcea.com/how-to-implement-equals-and-hashcode-using-the-jpa-entity-identifier/
        return getClass().hashCode();
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "ReferenceTom{" +
            "id=" + getId() +
            ", referenceTomImpl='" + getReferenceTomImpl() + "'" +
            "}";
    }
}
