package com.emerald.rcm.backend.repository;

import com.emerald.rcm.backend.domain.QuestionnaireNonConformity;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the QuestionnaireNonConformity entity.
 */
@Repository
public interface QuestionnaireNonConformityRepository extends JpaRepository<QuestionnaireNonConformity, Long> {
    default Optional<QuestionnaireNonConformity> findOneWithEagerRelationships(Long id) {
        return this.findOneWithToOneRelationships(id);
    }

    default List<QuestionnaireNonConformity> findAllWithEagerRelationships() {
        return this.findAllWithToOneRelationships();
    }

    default Page<QuestionnaireNonConformity> findAllWithEagerRelationships(Pageable pageable) {
        return this.findAllWithToOneRelationships(pageable);
    }

    @Query(
        value = "select questionnaireNonConformity from QuestionnaireNonConformity questionnaireNonConformity left join fetch questionnaireNonConformity.tom",
        countQuery = "select count(questionnaireNonConformity) from QuestionnaireNonConformity questionnaireNonConformity"
    )
    Page<QuestionnaireNonConformity> findAllWithToOneRelationships(Pageable pageable);

    @Query(
        "select questionnaireNonConformity from QuestionnaireNonConformity questionnaireNonConformity left join fetch questionnaireNonConformity.tom"
    )
    List<QuestionnaireNonConformity> findAllWithToOneRelationships();

    @Query(
        "select questionnaireNonConformity from QuestionnaireNonConformity questionnaireNonConformity left join fetch questionnaireNonConformity.tom where questionnaireNonConformity.id =:id"
    )
    Optional<QuestionnaireNonConformity> findOneWithToOneRelationships(@Param("id") Long id);
}
