package com.emerald.rcm.backend.repository;

import com.emerald.rcm.backend.domain.ReferenceTom;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the ReferenceTom entity.
 */
@Repository
public interface ReferenceTomRepository extends JpaRepository<ReferenceTom, Long> {
    default Optional<ReferenceTom> findOneWithEagerRelationships(Long id) {
        return this.findOneWithToOneRelationships(id);
    }

    default List<ReferenceTom> findAllWithEagerRelationships() {
        return this.findAllWithToOneRelationships();
    }

    default Page<ReferenceTom> findAllWithEagerRelationships(Pageable pageable) {
        return this.findAllWithToOneRelationships(pageable);
    }

    @Query(
        value = "select referenceTom from ReferenceTom referenceTom left join fetch referenceTom.tom",
        countQuery = "select count(referenceTom) from ReferenceTom referenceTom"
    )
    Page<ReferenceTom> findAllWithToOneRelationships(Pageable pageable);

    @Query("select referenceTom from ReferenceTom referenceTom left join fetch referenceTom.tom")
    List<ReferenceTom> findAllWithToOneRelationships();

    @Query("select referenceTom from ReferenceTom referenceTom left join fetch referenceTom.tom where referenceTom.id =:id")
    Optional<ReferenceTom> findOneWithToOneRelationships(@Param("id") Long id);
}
