package com.emerald.rcm.backend.repository;

import com.emerald.rcm.backend.domain.SecurityControlCategory;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the SecurityControlCategory entity.
 */
@Repository
public interface SecurityControlCategoryRepository extends JpaRepository<SecurityControlCategory, Long> {
    default Optional<SecurityControlCategory> findOneWithEagerRelationships(Long id) {
        return this.findOneWithToOneRelationships(id);
    }

    default List<SecurityControlCategory> findAllWithEagerRelationships() {
        return this.findAllWithToOneRelationships();
    }

    default Page<SecurityControlCategory> findAllWithEagerRelationships(Pageable pageable) {
        return this.findAllWithToOneRelationships(pageable);
    }

    @Query(
        value = "select securityControlCategory from SecurityControlCategory securityControlCategory left join fetch securityControlCategory.securityControlFramework",
        countQuery = "select count(securityControlCategory) from SecurityControlCategory securityControlCategory"
    )
    Page<SecurityControlCategory> findAllWithToOneRelationships(Pageable pageable);

    @Query(
        "select securityControlCategory from SecurityControlCategory securityControlCategory left join fetch securityControlCategory.securityControlFramework"
    )
    List<SecurityControlCategory> findAllWithToOneRelationships();

    @Query(
        "select securityControlCategory from SecurityControlCategory securityControlCategory left join fetch securityControlCategory.securityControlFramework where securityControlCategory.id =:id"
    )
    Optional<SecurityControlCategory> findOneWithToOneRelationships(@Param("id") Long id);
}
