package com.emerald.rcm.backend.repository;

import com.emerald.rcm.backend.domain.SecurityMetric;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the SecurityMetric entity.
 */
@Repository
public interface SecurityMetricRepository extends JpaRepository<SecurityMetric, Long> {
    default Optional<SecurityMetric> findOneWithEagerRelationships(Long id) {
        return this.findOneWithToOneRelationships(id);
    }

    default List<SecurityMetric> findAllWithEagerRelationships() {
        return this.findAllWithToOneRelationships();
    }

    default Page<SecurityMetric> findAllWithEagerRelationships(Pageable pageable) {
        return this.findAllWithToOneRelationships(pageable);
    }

    @Query(
        value = "select securityMetric from SecurityMetric securityMetric left join fetch securityMetric.referenceTom left join fetch securityMetric.resourceType",
        countQuery = "select count(securityMetric) from SecurityMetric securityMetric"
    )
    Page<SecurityMetric> findAllWithToOneRelationships(Pageable pageable);

    @Query(
        "select securityMetric from SecurityMetric securityMetric left join fetch securityMetric.referenceTom left join fetch securityMetric.resourceType"
    )
    List<SecurityMetric> findAllWithToOneRelationships();

    @Query(
        "select securityMetric from SecurityMetric securityMetric left join fetch securityMetric.referenceTom left join fetch securityMetric.resourceType where securityMetric.id =:id"
    )
    Optional<SecurityMetric> findOneWithToOneRelationships(@Param("id") Long id);
}
