package com.emerald.rcm.backend.repository;

import com.emerald.rcm.backend.domain.SimilarControl;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the SimilarControl entity.
 */
@Repository
public interface SimilarControlRepository extends JpaRepository<SimilarControl, Long> {
    default Optional<SimilarControl> findOneWithEagerRelationships(Long id) {
        return this.findOneWithToOneRelationships(id);
    }

    default List<SimilarControl> findAllWithEagerRelationships() {
        return this.findAllWithToOneRelationships();
    }

    default Page<SimilarControl> findAllWithEagerRelationships(Pageable pageable) {
        return this.findAllWithToOneRelationships(pageable);
    }

    @Query(
        value = "select similarControl from SimilarControl similarControl left join fetch similarControl.securityControl",
        countQuery = "select count(similarControl) from SimilarControl similarControl"
    )
    Page<SimilarControl> findAllWithToOneRelationships(Pageable pageable);

    @Query("select similarControl from SimilarControl similarControl left join fetch similarControl.securityControl")
    List<SimilarControl> findAllWithToOneRelationships();

    @Query(
        "select similarControl from SimilarControl similarControl left join fetch similarControl.securityControl where similarControl.id =:id"
    )
    Optional<SimilarControl> findOneWithToOneRelationships(@Param("id") Long id);
}
