package com.emerald.rcm.backend.repository;

import com.emerald.rcm.backend.domain.Tom;
import java.util.List;
import java.util.Optional;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.*;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the Tom entity.
 *
 * When extending this class, extend TomRepositoryWithBagRelationships too.
 * For more information refer to https://github.com/jhipster/generator-jhipster/issues/17990.
 */
@Repository
public interface TomRepository extends TomRepositoryWithBagRelationships, JpaRepository<Tom, Long> {
    default Optional<Tom> findOneWithEagerRelationships(Long id) {
        return this.fetchBagRelationships(this.findOneWithToOneRelationships(id));
    }

    default List<Tom> findAllWithEagerRelationships() {
        return this.fetchBagRelationships(this.findAllWithToOneRelationships());
    }

    default Page<Tom> findAllWithEagerRelationships(Pageable pageable) {
        return this.fetchBagRelationships(this.findAllWithToOneRelationships(pageable));
    }

    @Query(value = "select tom from Tom tom left join fetch tom.securityControl", countQuery = "select count(tom) from Tom tom")
    Page<Tom> findAllWithToOneRelationships(Pageable pageable);

    @Query("select tom from Tom tom left join fetch tom.securityControl")
    List<Tom> findAllWithToOneRelationships();

    @Query("select tom from Tom tom left join fetch tom.securityControl where tom.id =:id")
    Optional<Tom> findOneWithToOneRelationships(@Param("id") Long id);
}
