package com.emerald.rcm.backend.security.oauth2;

import com.emerald.rcm.backend.security.SecurityUtils;

import reactor.core.publisher.Mono;

import java.util.List;

import org.springframework.core.convert.converter.Converter;
import org.springframework.security.authentication.AbstractAuthenticationToken;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.oauth2.jwt.Jwt;
import org.springframework.security.oauth2.server.resource.authentication.JwtAuthenticationToken;
import org.springframework.stereotype.Component;

@Component
public class JwtGrantedAuthorityConverter implements Converter<Jwt, AbstractAuthenticationToken> {
    public JwtGrantedAuthorityConverter() {
        // Bean extracting authority.
    }

    @Override
    public AbstractAuthenticationToken convert(Jwt jwt) {
        List<GrantedAuthority> authorities = SecurityUtils.extractAuthorityFromClaims(jwt.getClaims());
        return new JwtAuthenticationToken(jwt, authorities);
    }
}
