package com.emerald.rcm.backend;

import com.emerald.rcm.backend.config.AsyncSyncConfiguration;
import com.emerald.rcm.backend.config.EmbeddedSQL;
import com.emerald.rcm.backend.config.JacksonConfiguration;
import com.emerald.rcm.backend.config.TestSecurityConfiguration;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import org.springframework.boot.test.context.SpringBootTest;

/**
 * Base composite annotation for integration tests.
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@SpringBootTest(
    classes = { RcmBackendApp.class, JacksonConfiguration.class, AsyncSyncConfiguration.class, TestSecurityConfiguration.class }
)
@EmbeddedSQL
public @interface IntegrationTest {
}
