package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class CloudServiceProviderTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));

    public static CloudServiceProvider getCloudServiceProviderSample1() {
        return new CloudServiceProvider().id(1L).acronym("acronym1").name("name1");
    }

    public static CloudServiceProvider getCloudServiceProviderSample2() {
        return new CloudServiceProvider().id(2L).acronym("acronym2").name("name2");
    }

    public static CloudServiceProvider getCloudServiceProviderRandomSampleGenerator() {
        return new CloudServiceProvider()
            .id(longCount.incrementAndGet())
            .acronym(UUID.randomUUID().toString())
            .name(UUID.randomUUID().toString());
    }
}
