package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class CloudServiceTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));

    public static CloudService getCloudServiceSample1() {
        return new CloudService().id(1L).acronym("acronym1").name("name1").type("type1");
    }

    public static CloudService getCloudServiceSample2() {
        return new CloudService().id(2L).acronym("acronym2").name("name2").type("type2");
    }

    public static CloudService getCloudServiceRandomSampleGenerator() {
        return new CloudService()
            .id(longCount.incrementAndGet())
            .acronym(UUID.randomUUID().toString())
            .name(UUID.randomUUID().toString())
            .type(UUID.randomUUID().toString());
    }
}
