package com.emerald.rcm.backend.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class QuestionAnswerAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAnswerAllPropertiesEquals(QuestionAnswer expected, QuestionAnswer actual) {
        assertQuestionAnswerAutoGeneratedPropertiesEquals(expected, actual);
        assertQuestionAnswerAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAnswerAllUpdatablePropertiesEquals(QuestionAnswer expected, QuestionAnswer actual) {
        assertQuestionAnswerUpdatableFieldsEquals(expected, actual);
        assertQuestionAnswerUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAnswerAutoGeneratedPropertiesEquals(QuestionAnswer expected, QuestionAnswer actual) {
        assertThat(expected)
            .as("Verify QuestionAnswer auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAnswerUpdatableFieldsEquals(QuestionAnswer expected, QuestionAnswer actual) {
        assertThat(expected)
            .as("Verify QuestionAnswer relevant properties")
            .satisfies(e -> assertThat(e.getAnswer()).as("check answer").isEqualTo(actual.getAnswer()))
            .satisfies(e -> assertThat(e.getValue()).as("check value").isEqualTo(actual.getValue()))
            .satisfies(e -> assertThat(e.getVisible()).as("check visible").isEqualTo(actual.getVisible()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAnswerUpdatableRelationshipsEquals(QuestionAnswer expected, QuestionAnswer actual) {}
}
