package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;

public class QuestionAnswerTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));
    private static final AtomicInteger intCount = new AtomicInteger(random.nextInt() + (2 * Short.MAX_VALUE));

    public static QuestionAnswer getQuestionAnswerSample1() {
        return new QuestionAnswer().id(1L).answer("answer1").value(1);
    }

    public static QuestionAnswer getQuestionAnswerSample2() {
        return new QuestionAnswer().id(2L).answer("answer2").value(2);
    }

    public static QuestionAnswer getQuestionAnswerRandomSampleGenerator() {
        return new QuestionAnswer().id(longCount.incrementAndGet()).answer(UUID.randomUUID().toString()).value(intCount.incrementAndGet());
    }
}
