package com.emerald.rcm.backend.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class QuestionAssuranceLevelAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAssuranceLevelAllPropertiesEquals(QuestionAssuranceLevel expected, QuestionAssuranceLevel actual) {
        assertQuestionAssuranceLevelAutoGeneratedPropertiesEquals(expected, actual);
        assertQuestionAssuranceLevelAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAssuranceLevelAllUpdatablePropertiesEquals(
        QuestionAssuranceLevel expected,
        QuestionAssuranceLevel actual
    ) {
        assertQuestionAssuranceLevelUpdatableFieldsEquals(expected, actual);
        assertQuestionAssuranceLevelUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAssuranceLevelAutoGeneratedPropertiesEquals(
        QuestionAssuranceLevel expected,
        QuestionAssuranceLevel actual
    ) {
        assertThat(expected)
            .as("Verify QuestionAssuranceLevel auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAssuranceLevelUpdatableFieldsEquals(QuestionAssuranceLevel expected, QuestionAssuranceLevel actual) {
        assertThat(expected)
            .as("Verify QuestionAssuranceLevel relevant properties")
            .satisfies(e -> assertThat(e.getAssuranceLevel()).as("check assuranceLevel").isEqualTo(actual.getAssuranceLevel()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionAssuranceLevelUpdatableRelationshipsEquals(
        QuestionAssuranceLevel expected,
        QuestionAssuranceLevel actual
    ) {}
}
