package com.emerald.rcm.backend.domain;

import static com.emerald.rcm.backend.domain.QuestionAssuranceLevelTestSamples.*;
import static com.emerald.rcm.backend.domain.QuestionTestSamples.*;
import static com.emerald.rcm.backend.domain.SecurityControlFrameworkTestSamples.*;
import static com.emerald.rcm.backend.domain.SecurityControlTestSamples.*;
import static com.emerald.rcm.backend.domain.TomTestSamples.*;
import static org.assertj.core.api.Assertions.assertThat;

import com.emerald.rcm.backend.web.rest.TestUtil;
import org.junit.jupiter.api.Test;

class QuestionTest {

    @Test
    void equalsVerifier() throws Exception {
        TestUtil.equalsVerifier(Question.class);
        Question question1 = getQuestionSample1();
        Question question2 = new Question();
        assertThat(question1).isNotEqualTo(question2);

        question2.setId(question1.getId());
        assertThat(question1).isEqualTo(question2);

        question2 = getQuestionSample2();
        assertThat(question1).isNotEqualTo(question2);
    }

    @Test
    void questionAssuranceLevelTest() {
        Question question = getQuestionRandomSampleGenerator();
        QuestionAssuranceLevel questionAssuranceLevelBack = getQuestionAssuranceLevelRandomSampleGenerator();

        question.setQuestionAssuranceLevel(questionAssuranceLevelBack);
        assertThat(question.getQuestionAssuranceLevel()).isEqualTo(questionAssuranceLevelBack);

        question.questionAssuranceLevel(null);
        assertThat(question.getQuestionAssuranceLevel()).isNull();
    }

    @Test
    void securityControlTest() {
        Question question = getQuestionRandomSampleGenerator();
        SecurityControl securityControlBack = getSecurityControlRandomSampleGenerator();

        question.setSecurityControl(securityControlBack);
        assertThat(question.getSecurityControl()).isEqualTo(securityControlBack);

        question.securityControl(null);
        assertThat(question.getSecurityControl()).isNull();
    }

    @Test
    void tomTest() {
        Question question = getQuestionRandomSampleGenerator();
        Tom tomBack = getTomRandomSampleGenerator();

        question.setTom(tomBack);
        assertThat(question.getTom()).isEqualTo(tomBack);

        question.tom(null);
        assertThat(question.getTom()).isNull();
    }

    @Test
    void securityControlFrameworkTest() {
        Question question = getQuestionRandomSampleGenerator();
        SecurityControlFramework securityControlFrameworkBack = getSecurityControlFrameworkRandomSampleGenerator();

        question.setSecurityControlFramework(securityControlFrameworkBack);
        assertThat(question.getSecurityControlFramework()).isEqualTo(securityControlFrameworkBack);

        question.securityControlFramework(null);
        assertThat(question.getSecurityControlFramework()).isNull();
    }
}
