package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class QuestionTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));

    public static Question getQuestionSample1() {
        return new Question()
            .id(1L)
            .code("code1")
            .question("question1")
            .defaultEvidence("defaultEvidence1")
            .defaultComment("defaultComment1");
    }

    public static Question getQuestionSample2() {
        return new Question()
            .id(2L)
            .code("code2")
            .question("question2")
            .defaultEvidence("defaultEvidence2")
            .defaultComment("defaultComment2");
    }

    public static Question getQuestionRandomSampleGenerator() {
        return new Question()
            .id(longCount.incrementAndGet())
            .code(UUID.randomUUID().toString())
            .question(UUID.randomUUID().toString())
            .defaultEvidence(UUID.randomUUID().toString())
            .defaultComment(UUID.randomUUID().toString());
    }
}
