package com.emerald.rcm.backend.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class QuestionnaireNonConformityAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionnaireNonConformityAllPropertiesEquals(
        QuestionnaireNonConformity expected,
        QuestionnaireNonConformity actual
    ) {
        assertQuestionnaireNonConformityAutoGeneratedPropertiesEquals(expected, actual);
        assertQuestionnaireNonConformityAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionnaireNonConformityAllUpdatablePropertiesEquals(
        QuestionnaireNonConformity expected,
        QuestionnaireNonConformity actual
    ) {
        assertQuestionnaireNonConformityUpdatableFieldsEquals(expected, actual);
        assertQuestionnaireNonConformityUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionnaireNonConformityAutoGeneratedPropertiesEquals(
        QuestionnaireNonConformity expected,
        QuestionnaireNonConformity actual
    ) {
        assertThat(expected)
            .as("Verify QuestionnaireNonConformity auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionnaireNonConformityUpdatableFieldsEquals(
        QuestionnaireNonConformity expected,
        QuestionnaireNonConformity actual
    ) {
        assertThat(expected)
            .as("Verify QuestionnaireNonConformity relevant properties")
            .satisfies(e -> assertThat(e.getQuestionnaireName()).as("check questionnaireName").isEqualTo(actual.getQuestionnaireName()))
            .satisfies(e -> assertThat(e.getComments()).as("check comments").isEqualTo(actual.getComments()))
            .satisfies(e -> assertThat(e.getCompliance()).as("check compliance").isEqualTo(actual.getCompliance()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertQuestionnaireNonConformityUpdatableRelationshipsEquals(
        QuestionnaireNonConformity expected,
        QuestionnaireNonConformity actual
    ) {
        assertThat(expected)
            .as("Verify QuestionnaireNonConformity relationships")
            .satisfies(e -> assertThat(e.getTom()).as("check tom").isEqualTo(actual.getTom()));
    }
}
