package com.emerald.rcm.backend.domain;

import static com.emerald.rcm.backend.domain.QuestionnaireNonConformityTestSamples.*;
import static com.emerald.rcm.backend.domain.TomTestSamples.*;
import static org.assertj.core.api.Assertions.assertThat;

import com.emerald.rcm.backend.web.rest.TestUtil;
import org.junit.jupiter.api.Test;

class QuestionnaireNonConformityTest {

    @Test
    void equalsVerifier() throws Exception {
        TestUtil.equalsVerifier(QuestionnaireNonConformity.class);
        QuestionnaireNonConformity questionnaireNonConformity1 = getQuestionnaireNonConformitySample1();
        QuestionnaireNonConformity questionnaireNonConformity2 = new QuestionnaireNonConformity();
        assertThat(questionnaireNonConformity1).isNotEqualTo(questionnaireNonConformity2);

        questionnaireNonConformity2.setId(questionnaireNonConformity1.getId());
        assertThat(questionnaireNonConformity1).isEqualTo(questionnaireNonConformity2);

        questionnaireNonConformity2 = getQuestionnaireNonConformitySample2();
        assertThat(questionnaireNonConformity1).isNotEqualTo(questionnaireNonConformity2);
    }

    @Test
    void tomTest() {
        QuestionnaireNonConformity questionnaireNonConformity = getQuestionnaireNonConformityRandomSampleGenerator();
        Tom tomBack = getTomRandomSampleGenerator();

        questionnaireNonConformity.setTom(tomBack);
        assertThat(questionnaireNonConformity.getTom()).isEqualTo(tomBack);

        questionnaireNonConformity.tom(null);
        assertThat(questionnaireNonConformity.getTom()).isNull();
    }
}
