package com.emerald.rcm.backend.domain;

import static com.emerald.rcm.backend.domain.QuestionAnswerTestSamples.*;
import static com.emerald.rcm.backend.domain.QuestionAssuranceLevelTestSamples.*;
import static com.emerald.rcm.backend.domain.QuestionTestSamples.*;
import static com.emerald.rcm.backend.domain.QuestionnaireTestSamples.*;
import static com.emerald.rcm.backend.domain.SecurityControlFrameworkTestSamples.*;
import static com.emerald.rcm.backend.domain.SecurityControlTestSamples.*;
import static org.assertj.core.api.Assertions.assertThat;

import com.emerald.rcm.backend.web.rest.TestUtil;
import org.junit.jupiter.api.Test;

class QuestionnaireTest {

    @Test
    void equalsVerifier() throws Exception {
        TestUtil.equalsVerifier(Questionnaire.class);
        Questionnaire questionnaire1 = getQuestionnaireSample1();
        Questionnaire questionnaire2 = new Questionnaire();
        assertThat(questionnaire1).isNotEqualTo(questionnaire2);

        questionnaire2.setId(questionnaire1.getId());
        assertThat(questionnaire1).isEqualTo(questionnaire2);

        questionnaire2 = getQuestionnaireSample2();
        assertThat(questionnaire1).isNotEqualTo(questionnaire2);
    }

    @Test
    void securityControlFrameworkTest() {
        Questionnaire questionnaire = getQuestionnaireRandomSampleGenerator();
        SecurityControlFramework securityControlFrameworkBack = getSecurityControlFrameworkRandomSampleGenerator();

        questionnaire.setSecurityControlFramework(securityControlFrameworkBack);
        assertThat(questionnaire.getSecurityControlFramework()).isEqualTo(securityControlFrameworkBack);

        questionnaire.securityControlFramework(null);
        assertThat(questionnaire.getSecurityControlFramework()).isNull();
    }

    @Test
    void securityControlTest() {
        Questionnaire questionnaire = getQuestionnaireRandomSampleGenerator();
        SecurityControl securityControlBack = getSecurityControlRandomSampleGenerator();

        questionnaire.setSecurityControl(securityControlBack);
        assertThat(questionnaire.getSecurityControl()).isEqualTo(securityControlBack);

        questionnaire.securityControl(null);
        assertThat(questionnaire.getSecurityControl()).isNull();
    }

    @Test
    void questionAssuranceLevelTest() {
        Questionnaire questionnaire = getQuestionnaireRandomSampleGenerator();
        QuestionAssuranceLevel questionAssuranceLevelBack = getQuestionAssuranceLevelRandomSampleGenerator();

        questionnaire.setQuestionAssuranceLevel(questionAssuranceLevelBack);
        assertThat(questionnaire.getQuestionAssuranceLevel()).isEqualTo(questionAssuranceLevelBack);

        questionnaire.questionAssuranceLevel(null);
        assertThat(questionnaire.getQuestionAssuranceLevel()).isNull();
    }

    @Test
    void questionTest() {
        Questionnaire questionnaire = getQuestionnaireRandomSampleGenerator();
        Question questionBack = getQuestionRandomSampleGenerator();

        questionnaire.setQuestion(questionBack);
        assertThat(questionnaire.getQuestion()).isEqualTo(questionBack);

        questionnaire.question(null);
        assertThat(questionnaire.getQuestion()).isNull();
    }

    @Test
    void questionAnswerTest() {
        Questionnaire questionnaire = getQuestionnaireRandomSampleGenerator();
        QuestionAnswer questionAnswerBack = getQuestionAnswerRandomSampleGenerator();

        questionnaire.setQuestionAnswer(questionAnswerBack);
        assertThat(questionnaire.getQuestionAnswer()).isEqualTo(questionAnswerBack);

        questionnaire.questionAnswer(null);
        assertThat(questionnaire.getQuestionAnswer()).isNull();
    }
}
