package com.emerald.rcm.backend.domain;

import static com.emerald.rcm.backend.domain.ReferenceTomTestSamples.*;
import static com.emerald.rcm.backend.domain.TomTestSamples.*;
import static org.assertj.core.api.Assertions.assertThat;

import com.emerald.rcm.backend.web.rest.TestUtil;
import org.junit.jupiter.api.Test;

class ReferenceTomTest {

    @Test
    void equalsVerifier() throws Exception {
        TestUtil.equalsVerifier(ReferenceTom.class);
        ReferenceTom referenceTom1 = getReferenceTomSample1();
        ReferenceTom referenceTom2 = new ReferenceTom();
        assertThat(referenceTom1).isNotEqualTo(referenceTom2);

        referenceTom2.setId(referenceTom1.getId());
        assertThat(referenceTom1).isEqualTo(referenceTom2);

        referenceTom2 = getReferenceTomSample2();
        assertThat(referenceTom1).isNotEqualTo(referenceTom2);
    }

    @Test
    void tomTest() {
        ReferenceTom referenceTom = getReferenceTomRandomSampleGenerator();
        Tom tomBack = getTomRandomSampleGenerator();

        referenceTom.setTom(tomBack);
        assertThat(referenceTom.getTom()).isEqualTo(tomBack);

        referenceTom.tom(null);
        assertThat(referenceTom.getTom()).isNull();
    }
}
