package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class ResourceTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));

    public static Resource getResourceSample1() {
        return new Resource()
            .id(1L)
            .acronym("acronym1")
            .name("name1")
            .confidentialityRisk("confidentialityRisk1")
            .availabilityRisk("availabilityRisk1")
            .integrityRisk("integrityRisk1");
    }

    public static Resource getResourceSample2() {
        return new Resource()
            .id(2L)
            .acronym("acronym2")
            .name("name2")
            .confidentialityRisk("confidentialityRisk2")
            .availabilityRisk("availabilityRisk2")
            .integrityRisk("integrityRisk2");
    }

    public static Resource getResourceRandomSampleGenerator() {
        return new Resource()
            .id(longCount.incrementAndGet())
            .acronym(UUID.randomUUID().toString())
            .name(UUID.randomUUID().toString())
            .confidentialityRisk(UUID.randomUUID().toString())
            .availabilityRisk(UUID.randomUUID().toString())
            .integrityRisk(UUID.randomUUID().toString());
    }
}
