package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class ResourceTypeTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));

    public static ResourceType getResourceTypeSample1() {
        return new ResourceType().id(1L).name("name1").ontologyTerm("ontologyTerm1");
    }

    public static ResourceType getResourceTypeSample2() {
        return new ResourceType().id(2L).name("name2").ontologyTerm("ontologyTerm2");
    }

    public static ResourceType getResourceTypeRandomSampleGenerator() {
        return new ResourceType()
            .id(longCount.incrementAndGet())
            .name(UUID.randomUUID().toString())
            .ontologyTerm(UUID.randomUUID().toString());
    }
}
