package com.emerald.rcm.backend.domain;

import static com.emerald.rcm.backend.domain.SecurityControlCategoryTestSamples.*;
import static com.emerald.rcm.backend.domain.SecurityControlFrameworkTestSamples.*;
import static org.assertj.core.api.Assertions.assertThat;

import com.emerald.rcm.backend.web.rest.TestUtil;
import org.junit.jupiter.api.Test;

class SecurityControlCategoryTest {

    @Test
    void equalsVerifier() throws Exception {
        TestUtil.equalsVerifier(SecurityControlCategory.class);
        SecurityControlCategory securityControlCategory1 = getSecurityControlCategorySample1();
        SecurityControlCategory securityControlCategory2 = new SecurityControlCategory();
        assertThat(securityControlCategory1).isNotEqualTo(securityControlCategory2);

        securityControlCategory2.setId(securityControlCategory1.getId());
        assertThat(securityControlCategory1).isEqualTo(securityControlCategory2);

        securityControlCategory2 = getSecurityControlCategorySample2();
        assertThat(securityControlCategory1).isNotEqualTo(securityControlCategory2);
    }

    @Test
    void securityControlFrameworkTest() {
        SecurityControlCategory securityControlCategory = getSecurityControlCategoryRandomSampleGenerator();
        SecurityControlFramework securityControlFrameworkBack = getSecurityControlFrameworkRandomSampleGenerator();

        securityControlCategory.setSecurityControlFramework(securityControlFrameworkBack);
        assertThat(securityControlCategory.getSecurityControlFramework()).isEqualTo(securityControlFrameworkBack);

        securityControlCategory.securityControlFramework(null);
        assertThat(securityControlCategory.getSecurityControlFramework()).isNull();
    }
}
