package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class SecurityControlTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));

    public static SecurityControl getSecurityControlSample1() {
        return new SecurityControl().id(1L).code("code1").name("name1").objective("objective1");
    }

    public static SecurityControl getSecurityControlSample2() {
        return new SecurityControl().id(2L).code("code2").name("name2").objective("objective2");
    }

    public static SecurityControl getSecurityControlRandomSampleGenerator() {
        return new SecurityControl()
            .id(longCount.incrementAndGet())
            .code(UUID.randomUUID().toString())
            .name(UUID.randomUUID().toString())
            .objective(UUID.randomUUID().toString());
    }
}
