package com.emerald.rcm.backend.domain;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicLong;

public class SecurityMetricTestSamples {

    private static final Random random = new Random();
    private static final AtomicLong longCount = new AtomicLong(random.nextInt() + (2 * Integer.MAX_VALUE));

    public static SecurityMetric getSecurityMetricSample1() {
        return new SecurityMetric()
            .id(1L)
            .metricId("metricId1")
            .category("category1")
            .name("name1")
            .source("source1")
            .scale("scale1")
            .operator("operator1")
            .targetValue("targetValue1")
            .targetValueDatatype("targetValueDatatype1")
            .interval("interval1")
            .targetResourceType("targetResourceType1")
            .securityFeature("securityFeature1")
            .keywords("keywords1");
    }

    public static SecurityMetric getSecurityMetricSample2() {
        return new SecurityMetric()
            .id(2L)
            .metricId("metricId2")
            .category("category2")
            .name("name2")
            .source("source2")
            .scale("scale2")
            .operator("operator2")
            .targetValue("targetValue2")
            .targetValueDatatype("targetValueDatatype2")
            .interval("interval2")
            .targetResourceType("targetResourceType2")
            .securityFeature("securityFeature2")
            .keywords("keywords2");
    }

    public static SecurityMetric getSecurityMetricRandomSampleGenerator() {
        return new SecurityMetric()
            .id(longCount.incrementAndGet())
            .metricId(UUID.randomUUID().toString())
            .category(UUID.randomUUID().toString())
            .name(UUID.randomUUID().toString())
            .source(UUID.randomUUID().toString())
            .scale(UUID.randomUUID().toString())
            .operator(UUID.randomUUID().toString())
            .targetValue(UUID.randomUUID().toString())
            .targetValueDatatype(UUID.randomUUID().toString())
            .interval(UUID.randomUUID().toString())
            .targetResourceType(UUID.randomUUID().toString())
            .securityFeature(UUID.randomUUID().toString())
            .keywords(UUID.randomUUID().toString());
    }
}
