package com.emerald.rcm.backend.domain;

import static com.emerald.rcm.backend.domain.SecurityControlTestSamples.*;
import static com.emerald.rcm.backend.domain.SimilarControlTestSamples.*;
import static org.assertj.core.api.Assertions.assertThat;

import com.emerald.rcm.backend.web.rest.TestUtil;
import org.junit.jupiter.api.Test;

class SimilarControlTest {

    @Test
    void equalsVerifier() throws Exception {
        TestUtil.equalsVerifier(SimilarControl.class);
        SimilarControl similarControl1 = getSimilarControlSample1();
        SimilarControl similarControl2 = new SimilarControl();
        assertThat(similarControl1).isNotEqualTo(similarControl2);

        similarControl2.setId(similarControl1.getId());
        assertThat(similarControl1).isEqualTo(similarControl2);

        similarControl2 = getSimilarControlSample2();
        assertThat(similarControl1).isNotEqualTo(similarControl2);
    }

    @Test
    void securityControlTest() {
        SimilarControl similarControl = getSimilarControlRandomSampleGenerator();
        SecurityControl securityControlBack = getSecurityControlRandomSampleGenerator();

        similarControl.setSecurityControl(securityControlBack);
        assertThat(similarControl.getSecurityControl()).isEqualTo(securityControlBack);

        similarControl.securityControl(null);
        assertThat(similarControl.getSecurityControl()).isNull();
    }
}
